Botan 1.10.17

Public Types | Public Member Functions | List of all members
Botan::SAFER_SK Class Reference

`#include <safer_sk.h>`

Inheritance diagram for Botan::SAFER_SK:

## Public Types
enum |

## Public Member Functions
size_t | block_size () const
void | clear ()
BlockCipher * | clone () const
void | decrypt (const byte in[], byte out[]) const
void | decrypt (byte block[]) const
void | decrypt_n (const byte in[], byte out[], size_t blocks) const
void | encrypt (const byte in[], byte out[]) const
void | encrypt (byte block[]) const
void | encrypt_n (const byte in[], byte out[], size_t blocks) const
Key_Length_Specification | key_spec () const
size_t | maximum_keylength () const
size_t | minimum_keylength () const
std::string | name () const
size_t | parallel_bytes () const
virtual size_t | parallelism () const
| SAFER_SK (size_t rounds)
void | set_key (const SymmetricKey &key)
void | set_key (const byte key[], size_t length)
bool | valid_keylength (size_t length) const

## Detailed Description

SAFER-SK

Definition at line 18 of file safer_sk.h.

## Member Enumeration Documentation

## ◆ anonymous enum

anonymous enum
| inherited

Definition at line 107 of file block_cipher.h.

107 { BLOCK_SIZE = BS };
Botan::Block_Cipher_Fixed_Params< 8, 16 >::BLOCK_SIZE
Definition: block_cipher.h:107

## Constructor & Destructor Documentation

## ◆ SAFER_SK()

Botan::SAFER_SK::SAFER_SK | ( | size_t | rounds | ) |

Parameters

  rounds | the number of rounds to use - must be between 1 and 13

Definition at line 247 of file safer_sk.cpp.

References name(), and Botan::MemoryRegion< T >::resize().

Referenced by clone().

248 {
249 if(rounds > 13 || rounds == 0)
250 throw Invalid_Argument(name() + ": Invalid number of rounds");
251
252 EK.resize(16 * rounds + 8);
253 }
Botan::MemoryRegion::resize
void resize(size_t n)
Definition: secmem.h:217
Botan::Invalid_Argument
std::invalid_argument Invalid_Argument
Definition: exceptn.h:20
Botan::SAFER_SK::name
std::string name() const
Definition: safer_sk.cpp:231

## Member Function Documentation

## ◆ block_size()

size_t Botan::Block_Cipher_Fixed_Params< BS, KMIN, 0 , 1 >::block_size | ( |  | ) | const
| inline virtual inherited

Returns
  block size of this algorithm

Implements Botan::BlockCipher.

Definition at line 108 of file block_cipher.h.

108 { return BS; }

## ◆ clear()

void Botan::SAFER_SK::clear | ( |  | ) |
| inline virtual

Zeroize internal state

Implements Botan::Algorithm.

Definition at line 24 of file safer_sk.h.

References Botan::zeroise().

24 { zeroise(EK); }
Botan::zeroise
void zeroise(MemoryRegion< T > &vec)
Definition: secmem.h:428

## ◆ clone()

BlockCipher * Botan::SAFER_SK::clone | ( |  | ) | const
| virtual

Get a new object representing the same algorithm as *this

Implements Botan::BlockCipher.

Definition at line 239 of file safer_sk.cpp.

References SAFER_SK().

240 {
241 return new SAFER_SK(get_rounds());
242 }
Botan::SAFER_SK::SAFER_SK
SAFER_SK(size_t rounds)
Definition: safer_sk.cpp:247

## ◆ decrypt() [1/2]

void Botan::BlockCipher::decrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inline inherited

Decrypt a block.

Parameters

  in | The ciphertext block to be decypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the decrypted block. Must be of length block_size().

Definition at line 57 of file block_cipher.h.

Referenced by Botan::DESX::decrypt_n().

58 { decrypt_n(in, out, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt() [2/2]

void Botan::BlockCipher::decrypt | ( | byte | block[] | ) | const
| inline inherited

Decrypt a block.

Parameters

  block | the ciphertext block to be decrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 74 of file block_cipher.h.

74 { decrypt_n(block, block, 1); }
Botan::BlockCipher::decrypt_n
virtual void decrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ decrypt_n()

void Botan::SAFER_SK::decrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Decrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 129 of file safer_sk.cpp.

References Botan::Block_Cipher_Fixed_Params< 8, 16 >::BLOCK_SIZE.

130 {
131 const size_t rounds = get_rounds();
132
133 for(size_t i = 0; i != blocks; ++i)
134 {
135 byte A = in[0], B = in[1], C = in[2], D = in[3],
136 E = in[4], F = in[5], G = in[6], H = in[7];
137
138 A ^= EK[16*rounds+0]; B -= EK[16*rounds+1]; C -= EK[16*rounds+2];
139 D ^= EK[16*rounds+3]; E ^= EK[16*rounds+4]; F -= EK[16*rounds+5];
140 G -= EK[16*rounds+6]; H ^= EK[16*rounds+7];
141
142 for(s32bit j = 16*(rounds-1); j >= 0; j -= 16)
143 {
144 byte T = E; E = B; B = C; C = T; T = F; F = D; D = G; G = T;
145 A -= E; B -= F; C -= G; D -= H; E -= A; F -= B; G -= C; H -= D;
146 A -= C; E -= G; B -= D; F -= H; C -= A; G -= E; D -= B; H -= F;
147 A -= B; C -= D; E -= F; G -= H; B -= A; D -= C; F -= E; H -= G;
148
149 A = LOG[A - EK[j+8 ] + 256]; B = EXP[B ^ EK[j+9 ]];
150 C = EXP[C ^ EK[j+10]]; D = LOG[D - EK[j+11] + 256];
151 E = LOG[E - EK[j+12] + 256]; F = EXP[F ^ EK[j+13]];
152 G = EXP[G ^ EK[j+14]]; H = LOG[H - EK[j+15] + 256];
153
154 A ^= EK[j+0]; B -= EK[j+1]; C -= EK[j+2]; D ^= EK[j+3];
155 E ^= EK[j+4]; F -= EK[j+5]; G -= EK[j+6]; H ^= EK[j+7];
156 }
157
158 out[0] = A; out[1] = B; out[2] = C; out[3] = D;
159 out[4] = E; out[5] = F; out[6] = G; out[7] = H;
160
161 in += BLOCK_SIZE;
162 out += BLOCK_SIZE;
163 }
164 }
Botan::Block_Cipher_Fixed_Params< 8, 16 >::BLOCK_SIZE
Definition: block_cipher.h:107
Botan::s32bit
signed int s32bit
Definition: types.h:37
Botan::byte
unsigned char byte
Definition: types.h:22

## ◆ encrypt() [1/2]

void Botan::BlockCipher::encrypt | ( | const byte | in[],
|  | byte | out[]
| ) |  | const
| inline inherited

Encrypt a block.

Parameters

  in | The plaintext block to be encrypted as a byte array. Must be of length block_size().
  out | The byte array designated to hold the encrypted block. Must be of length block_size().

Definition at line 47 of file block_cipher.h.

Referenced by Botan::aont_unpackage(), Botan::OFB::cipher(), Botan::DESX::encrypt_n(), Botan::OFB::set_iv(), Botan::CFB_Encryption::set_iv(), Botan::XTS_Encryption::set_iv(), Botan::CFB_Decryption::set_iv(), and Botan::XTS_Decryption::set_iv().

48 { encrypt_n(in, out, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt() [2/2]

void Botan::BlockCipher::encrypt | ( | byte | block[] | ) | const
| inline inherited

Encrypt a block.

Parameters

  block | the plaintext block to be encrypted Must be of length block_size(). Will hold the result when the function has finished.

Definition at line 66 of file block_cipher.h.

66 { encrypt_n(block, block, 1); }
Botan::BlockCipher::encrypt_n
virtual void encrypt_n(const byte in[], byte out[], size_t blocks) const =0

## ◆ encrypt_n()

void Botan::SAFER_SK::encrypt_n | ( | const byte | in[],
|  | byte | out[],
|  | size_t | blocks
| ) |  | const
| virtual

Encrypt one or more blocks

Parameters

  in | the input buffer (multiple of block_size())
  out | the output buffer (same size as in)
  blocks | the number of blocks to process

Implements Botan::BlockCipher.

Definition at line 91 of file safer_sk.cpp.

References Botan::Block_Cipher_Fixed_Params< 8, 16 >::BLOCK_SIZE.

92 {
93 const size_t rounds = get_rounds();
94
95 for(size_t i = 0; i != blocks; ++i)
96 {
97 byte A = in[0], B = in[1], C = in[2], D = in[3],
98 E = in[4], F = in[5], G = in[6], H = in[7], X, Y;
99
100 for(size_t j = 0; j != 16*rounds; j += 16)
101 {
102 A = EXP[A ^ EK[j ]]; B = LOG[B + EK[j+1]];
103 C = LOG[C + EK[j+2]]; D = EXP[D ^ EK[j+3]];
104 E = EXP[E ^ EK[j+4]]; F = LOG[F + EK[j+5]];
105 G = LOG[G + EK[j+6]]; H = EXP[H ^ EK[j+7]];
106
107 A += EK[j+ 8]; B ^= EK[j+ 9]; C ^= EK[j+10]; D += EK[j+11];
108 E += EK[j+12]; F ^= EK[j+13]; G ^= EK[j+14]; H += EK[j+15];
109
110 B += A; D += C; F += E; H += G; A += B; C += D; E += F; G += H;
111 C += A; G += E; D += B; H += F; A += C; E += G; B += D; F += H;
112 H += D; Y = D + H; D = B + F; X = B + D; B = A + E;
113 A += B; F = C + G; E = C + F; C = X; G = Y;
114 }
115
116 out[0] = A ^ EK[16*rounds+0]; out[1] = B + EK[16*rounds+1];
117 out[2] = C + EK[16*rounds+2]; out[3] = D ^ EK[16*rounds+3];
118 out[4] = E ^ EK[16*rounds+4]; out[5] = F + EK[16*rounds+5];
119 out[6] = G + EK[16*rounds+6]; out[7] = H ^ EK[16*rounds+7];
120
121 in += BLOCK_SIZE;
122 out += BLOCK_SIZE;
123 }
124 }
Botan::Block_Cipher_Fixed_Params< 8, 16 >::BLOCK_SIZE
Definition: block_cipher.h:107
Botan::byte
unsigned char byte
Definition: types.h:22

## ◆ key_spec()

Key_Length_Specification Botan::Block_Cipher_Fixed_Params< BS, KMIN, 0 , 1 >::key_spec | ( |  | ) | const
| inline virtual inherited

Returns
  object describing limits on key size

Implements Botan::SymmetricAlgorithm.

Definition at line 110 of file block_cipher.h.

111 {
112 return Key_Length_Specification(KMIN, KMAX, KMOD);
113 }

## ◆ maximum_keylength()

size_t Botan::SymmetricAlgorithm::maximum_keylength | ( |  | ) | const
| inline inherited

Returns
  minimum allowed key length

Definition at line 33 of file sym_algo.h.

34 {
35 return key_spec().maximum_keylength();
36 }
Botan::Key_Length_Specification::maximum_keylength
size_t maximum_keylength() const
Definition: key_spec.h:69
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

## ◆ minimum_keylength()

size_t Botan::SymmetricAlgorithm::minimum_keylength | ( |  | ) | const
| inline inherited

Returns
  maxmium allowed key length

Definition at line 41 of file sym_algo.h.

42 {
43 return key_spec().minimum_keylength();
44 }
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0
Botan::Key_Length_Specification::minimum_keylength
size_t minimum_keylength() const
Definition: key_spec.h:61

## ◆ name()

std::string Botan::SAFER_SK::name | ( |  | ) | const
| virtual

Returns
  name of this algorithm

Implements Botan::Algorithm.

Definition at line 231 of file safer_sk.cpp.

References Botan::to_string().

Referenced by SAFER_SK().

232 {
233 return "SAFER-SK(" + to_string(get_rounds()) + ")";
234 }
Botan::to_string
std::string to_string(u64bit n, size_t min_len)
Definition: parsing.cpp:42

## ◆ parallel_bytes()

size_t Botan::BlockCipher::parallel_bytes | ( |  | ) | const
| inline inherited

Returns
  prefererred parallelism of this cipher in bytes

Definition at line 35 of file block_cipher.h.

36 {
37 return parallelism() * block_size() * BOTAN_BLOCK_CIPHER_PAR_MULT;
38 }
Botan::BlockCipher::parallelism
virtual size_t parallelism() const
Definition: block_cipher.h:30
Botan::BlockCipher::block_size
virtual size_t block_size() const =0

## ◆ parallelism()

virtual size_t Botan::BlockCipher::parallelism | ( |  | ) | const
| inline virtual inherited

Returns
  native parallelism of this cipher in blocks

Reimplemented in Botan::AES_256_NI, Botan::AES_192_NI, Botan::AES_128_NI, Botan::IDEA_SSE2, Botan::Noekeon_SIMD, Botan::Serpent_SIMD, and Botan::XTEA_SIMD.

Definition at line 30 of file block_cipher.h.

30 { return 1; }

## ◆ set_key() [1/2]

void Botan::SymmetricAlgorithm::set_key | ( | const SymmetricKey & | key | ) |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the SymmetricKey to be set.

Definition at line 60 of file sym_algo.h.

References Botan::OctetString::begin(), and Botan::OctetString::length().

Referenced by Botan::aont_unpackage(), Botan::Lion::decrypt_n(), Botan::PKCS5_PBKDF2::derive_key(), Botan::ECB_Decryption::ECB_Decryption(), Botan::ECB_Encryption::ECB_Encryption(), Botan::Lion::encrypt_n(), Botan::HMAC_RNG::HMAC_RNG(), Botan::MAC_Filter::MAC_Filter(), Botan::HMAC_RNG::reseed(), Botan::XTS_Encryption::set_key(), Botan::EAX_Base::set_key(), Botan::XTS_Decryption::set_key(), Botan::Record_Writer::set_keys(), Botan::Record_Reader::set_keys(), and Botan::StreamCipher_Filter::StreamCipher_Filter().

61 { set_key(key.begin(), key.length()); }
Botan::SymmetricAlgorithm::set_key
void set_key(const SymmetricKey &key)
Definition: sym_algo.h:60

## ◆ set_key() [2/2]

void Botan::SymmetricAlgorithm::set_key | ( | const byte | key[],
|  | size_t | length
| ) |  |
| inline inherited

Set the symmetric key of this object.

Parameters

  key | the to be set as a byte array.
  length | in bytes of key param

Definition at line 68 of file sym_algo.h.

69 {
70 if(!valid_keylength(length))
71 throw Invalid_Key_Length(name(), length);
72 key_schedule(key, length);
73 }
Botan::SymmetricAlgorithm::valid_keylength
bool valid_keylength(size_t length) const
Definition: sym_algo.h:51
Botan::Algorithm::name
virtual std::string name() const =0

## ◆ valid_keylength()

bool Botan::SymmetricAlgorithm::valid_keylength | ( | size_t | length | ) | const
| inline inherited

Check whether a given key length is valid for this algorithm.

Parameters

  length | the key length to be checked.

Returns
  true if the key length is valid.

Definition at line 51 of file sym_algo.h.

Referenced by Botan::aont_unpackage(), Botan::HMAC_RNG::HMAC_RNG(), and Botan::Lion::Lion().

52 {
53 return key_spec().valid_keylength(length);
54 }
Botan::Key_Length_Specification::valid_keylength
bool valid_keylength(size_t length) const
Definition: key_spec.h:51
Botan::SymmetricAlgorithm::key_spec
virtual Key_Length_Specification key_spec() const =0

The documentation for this class was generated from the following files:

- src/block/safer/safer_sk.h
- src/block/safer/safer_sk.cpp